
! Copyright (C) 2020 Chung-Yu Wang, J. K. Dewhurst, S. Sharma and
! E. K. U. Gross. This file is distributed under the terms of the GNU General
! Public License. See the file COPYING for license details.

subroutine hmlepha(ik,a)
use modmain
use modphonon
use modbog
use modomp
implicit none
! arguments
integer, intent(in) :: ik
complex(8), intent(out) :: a(nstsv,nstsv)
! local variables
integer iq,jq,ikq,isym
integer ist1,ist2,nthd
integer i1,i2,j1,j2,l1,l2
real(8) vl(3),t0
complex(8) z1,z2,z3
! automatic arrays
complex(4) ephmat(nstsv,nstsv,nbph)
! prefactor
if (dengy0.gt.0.d0) then
  t0=dengy0
else
  t0=dengy
end if
t0=-2.d0*wqptnr*ephscf(1)**2/t0
a(:,:)=0.d0
if (anomalous) goto 10
ist1=isteph(1)
ist2=isteph(2)
! parallel loop over non-reduced q-points
call holdthd(nqptnr,nthd)
!$OMP PARALLEL DO DEFAULT(SHARED) &
!$OMP PRIVATE(ephmat,jq,vl,isym,ikq) &
!$OMP PRIVATE(l1,l2,z1,z2,z3,i1,i2,j1,j2) &
!$OMP REDUCTION(+:a) &
!$OMP NUM_THREADS(nthd)
do iq=1,nqptnr
! equivalent reduced q-point
  jq=ivqiq(ivq(1,iq),ivq(2,iq),ivq(3,iq))
! k+q-vector in lattice coordinates
  vl(:)=vkl(:,ik)+vql(:,iq)
! index to reduced k+q-vector
  call findkpt(vl,isym,ikq)
! read in the electron-phonon matrix elements from file
  call getephmkq(iq,ik,ephmat)
  do l2=1,nbph
    if (wphq(l2,jq).lt.wphcut) cycle
    do l1=1,nbph
      if (wphq(l1,jq).lt.wphcut) cycle
      z1=t0*dble(dxx(l1,l2,jq)+dxw(l1,l2,jq))
      do i2=ist1,ist2
        do i1=ist1,i2
          z2=0.d0
          do j2=ist1,ist2
            z3=z1*conjg(ephmat(j2,i1,l1))
            do j1=ist1,ist2
              z2=z2+z3*ephmat(j1,i2,l2)*dvv(j1,j2,ikq)
            end do
          end do
          a(i1,i2)=a(i1,i2)+z2
        end do
      end do
    end do
  end do
end do
!$OMP END PARALLEL DO
call freethd(nthd)
10 continue
! add the second-variational eigenvalues minus the Fermi energy
do i1=1,nstsv
  a(i1,i1)=a(i1,i1)+evalsv(i1,ik)-efermi
end do
end subroutine

