
! Copyright (C) 2020 Chung-Yu Wang, J. K. Dewhurst, S. Sharma and
! E. K. U. Gross. This file is distributed under the terms of the GNU General
! Public License. See the file COPYING for license details.

subroutine hmlephde(iq,d,e)
use modmain
use modphonon
use modbog
use modomp
implicit none
! arguments
integer, intent(in) :: iq
complex(8), intent(out) :: d(nbph,nbph),e(nbph,nbph)
! local variables
integer ik,jk,ikq,isym
integer ist1,ist2,nthd
integer i1,i2,j1,j2,l1,l2
real(8) vl(3),t0
complex(8) z1,z2,z3
! automatic arrays
complex(4) ephmat(nstsv,nstsv,nbph)
! prefactor
if (dengy0.gt.0.d0) then
  t0=dengy0
else
  t0=dengy
end if
t0=-occmax*wkptnr*ephscf(1)**2/t0
e(:,:)=0.d0
ist1=isteph(1)
ist2=isteph(2)
! parallel loop over non-reduced k-points
call holdthd(nkptnr,nthd)
!$OMP PARALLEL DO DEFAULT(SHARED) &
!$OMP PRIVATE(ephmat,jk,vl,isym,ikq) &
!$OMP PRIVATE(l1,l2,z1,z2,z3,j1,j2,i1,i2) &
!$OMP REDUCTION(+:e) &
!$OMP NUM_THREADS(nthd)
do ik=1,nkptnr
! equivalent reduced k-point
  jk=ivkik(ivk(1,ik),ivk(2,ik),ivk(3,ik))
! k+q-vector in lattice coordinates
  vl(:)=vkl(:,ik)+vql(:,iq)
! index to reduced k+q-vector
  call findkpt(vl,isym,ikq)
! read in the electron-phonon matrix elements from file
  call getephmkq(iq,ik,ephmat)
  do l2=1,nbph
    if (wphq(l2,iq).lt.wphcut) cycle
    do l1=1,l2
      if (wphq(l1,iq).lt.wphcut) cycle
      z1=0.d0
      if (anomalous) then
        do j1=ist1,ist2
          do i1=ist1,ist2
            z2=conjg(duv(i1,j1,ikq))
            do j2=ist1,ist2
              z3=z2*conjg(ephmat(j2,i1,l1))
              do i2=ist1,ist2
                z1=z1+z3*ephmat(j1,i2,l2)*duv(i2,j2,jk)
              end do
            end do
          end do
        end do
      else
        do i1=ist1,ist2
          do j2=ist1,ist2
            z2=conjg(ephmat(j2,i1,l1))
            do i2=ist1,ist2
              z3=z2*dvv(i1,i2,jk)
              do j1=ist1,ist2
                z1=z1+z3*ephmat(j1,i2,l2)*dvv(j1,j2,ikq)
              end do
            end do
          end do
        end do
      end if
      e(l1,l2)=e(l1,l2)+t0*z1
    end do
  end do
end do
!$OMP END PARALLEL DO
call freethd(nthd)
! set the lower triangular part of the Hermitian matrix E
do l1=1,nbph
  do l2=1,l1-1
    e(l1,l2)=conjg(e(l2,l1))
  end do
end do
! determine the matrix D = D0 or D = D0 + E
if (tephde) then
  d(:,:)=e(:,:)
else
  d(:,:)=0.d0
end if
do l1=1,nbph
  d(l1,l1)=d(l1,l1)+wphq(l1,iq)
end do
end subroutine

